<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/serde_derive-1.0.140/src/dummy.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>dummy.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../serde_derive/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">proc_macro2</span>::{<span class="ident">Ident</span>, <span class="ident">TokenStream</span>};
<span class="kw">use</span> <span class="ident">quote::format_ident</span>;

<span class="kw">use</span> <span class="ident">syn</span>;
<span class="kw">use</span> <span class="ident">try</span>;

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">wrap_in_const</span>(
    <span class="ident">serde_path</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">syn::Path</span><span class="op">&gt;</span>,
    <span class="ident">trait_</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>,
    <span class="ident">ty</span>: <span class="kw-2">&amp;</span><span class="ident">Ident</span>,
    <span class="ident">code</span>: <span class="ident">TokenStream</span>,
) -&gt; <span class="ident">TokenStream</span> {
    <span class="kw">let</span> <span class="ident">try_replacement</span> <span class="op">=</span> <span class="ident">try::replacement</span>();

    <span class="kw">let</span> <span class="ident">dummy_const</span> <span class="op">=</span> <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">no_underscore_consts</span>) {
        <span class="macro">format_ident!</span>(<span class="string">&quot;_IMPL_{}_FOR_{}&quot;</span>, <span class="ident">trait_</span>, <span class="ident">unraw</span>(<span class="ident">ty</span>))
    } <span class="kw">else</span> {
        <span class="macro">format_ident!</span>(<span class="string">&quot;_&quot;</span>)
    };

    <span class="kw">let</span> <span class="ident">use_serde</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">serde_path</span> {
        <span class="prelude-val">Some</span>(<span class="ident">path</span>) =&gt; <span class="macro">quote!</span> {
            <span class="kw">use</span> #<span class="ident">path</span> <span class="kw">as</span> <span class="ident">_serde</span>;
        },
        <span class="prelude-val">None</span> =&gt; <span class="macro">quote!</span> {
            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_extern_crates</span>, <span class="ident">clippy::useless_attribute</span>)]</span>
            <span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">serde</span> <span class="kw">as</span> <span class="ident">_serde</span>;
        },
    };

    <span class="macro">quote!</span> {
        <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_upper_case_globals</span>, <span class="ident">unused_attributes</span>, <span class="ident">unused_qualifications</span>)]</span>
        <span class="kw">const</span> #<span class="ident">dummy_const</span>: () <span class="op">=</span> {
            #<span class="ident">use_serde</span>
            #<span class="ident">try_replacement</span>
            #<span class="ident">code</span>
        };
    }
}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="kw">fn</span> <span class="ident">unraw</span>(<span class="ident">ident</span>: <span class="kw-2">&amp;</span><span class="ident">Ident</span>) -&gt; <span class="ident">String</span> {
    <span class="comment">// str::trim_start_matches was added in 1.30, trim_left_matches deprecated</span>
    <span class="comment">// in 1.33. We currently support rustc back to 1.15 so we need to continue</span>
    <span class="comment">// to use the deprecated one.</span>
    <span class="ident">ident</span>.<span class="ident">to_string</span>().<span class="ident">trim_left_matches</span>(<span class="string">&quot;r#&quot;</span>).<span class="ident">to_owned</span>()
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="serde_derive" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>